Attribute VB_Name = "DefineModule"
Option Explicit

Public Const OPTION_FILE = "vb6oauth.ini"

Public ClientId As String
Public ClientSecret As String
Public TenantId As String

Public Const HEADER_MAX as Long = 10000
Public Const BODY_MAX as Long = 100000
Public Const PATH_MAX = 256

Public Const MAX_PATH = 260
Public Const SW_SHOW = 5
Public Const GWL_WNDPROC = -4
Public Const WM_GET_CODE As Long = &H8001&

Private OldWndProc As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Function WndProc(ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    WndProc = 0
    If Msg = WM_GET_CODE Then
        FormMain.GetCode
    Else
        WndProc = CallWindowProc(OldWndProc, hwnd, Msg, wParam, lParam)
    End If
End Function

Public Sub SetWndProc(ByVal hwnd As Long)
    OldWndProc = GetWindowLong(hwnd, GWL_WNDPROC)
    Call SetWindowLong(hwnd, GWL_WNDPROC, AddressOf WndProc)
End Sub

Public Sub ResetWndProc(ByVal hwnd As Long)
    Call SetWindowLong(hwnd, GWL_WNDPROC, OldWndProc)
End Sub

Public Function GetIniString(ByVal Key As String, ByVal default As String) As String
    Dim s As String * 10000
    GetPrivateProfileString "OAUTH2", Key, default, s, 10000, App.Path + "\" + OPTION_FILE
    If InStr(s, Chr(0)) > 0 Then
        GetIniString = Left(s, InStr(s, Chr(0)) - 1)
    Else
        GetIniString = s
    End If
End Function

Public Function GetIniInt(ByVal Key As String, ByVal default As Long) As Integer
    GetIniInt = GetPrivateProfileInt("OAUTH2", Key, default, App.Path + "\" + OPTION_FILE)
End Function

Public Sub SetIniString(ByVal Key As String, ByVal s As String)
    WritePrivateProfileString "OAUTH2", Key, s, App.Path + "\" + OPTION_FILE
End Sub

Public Sub SetIniInt(ByVal Key As String, ByVal data As Integer)
    Dim s As String
    s = Str(data)
    WritePrivateProfileString "OAUTH2", Key, s, App.Path + "\" + OPTION_FILE
End Sub

